=== debian/changelog ===
wolfssl (5.8.2-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Mark wolfSSL_Atomic_Int_* symbols as optional to build on archs with no
    atomic operations.

 -- Bastian Germann <bage@debian.org>  Sat, 30 Aug 2025 12:23:05 +0200

wolfssl (5.8.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Move to unstable.

 -- Bastian Germann <bage@debian.org>  Sat, 30 Aug 2025 08:58:18 +0200

wolfssl (5.8.2-1) experimental; urgency=medium

  * New upstream release.
  * Update debian/copyright to GPL3+.
  * Disable old TLS.
  * Disable CRL Monitor.

 -- Jacob Barthelmeh <sirkilamole@msn.com>  Tue, 12 Aug 2025 15:13:06 -0600
