=== debian/control ===
Source: wolfssl
Priority: optional
Maintainer: Jacob Barthelmeh <sirkilamole@msn.com>
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 libpcap0.8-dev,
 openssl
Standards-Version: 4.6.1
Rules-Requires-Root: no
Section: libs
Homepage: https://www.wolfssl.com/products/wolfssl/

Package: libwolfssl44
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: wolfSSL encryption library
 wolfSSL is a small, portable, embedded SSL/TLS programming library
 targeted for use by embedded systems developers. It was formerly
 known as CyaSSL.
 .
 It is an implementation of SSL/TLS written in the C language.
 wolfSSL includes both a client and server implementation,
 progressive cipher support, key and certificate generation, OCSP
 and CRL, access to the underlying cryptography modules, and more.
 .
 wolfSSL also includes an OpenSSL compatibility interface with the
 most commonly used OpenSSL functions.
 .
 wolfSSL is solely provided as an alternative to OpenSSL for
 packages whose licenses are incompatible to Apache 2.0. For details,
 please see Bug#1023697.

Package: libwolfssl-dev
Section: libdevel
Architecture: any
Multi-Arch: no
Depends:
 libwolfssl44 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for the wolfSSL encryption library
 wolfSSL is a small, portable, embedded SSL/TLS programming library
 targeted for use by embedded systems developers. It was formerly
 known as CyaSSL.
 .
 It is an implementation of SSL/TLS written in the C language.
 wolfSSL includes both a client and server implementation,
 progressive cipher support, key and certificate generation, OCSP
 and CRL, access to the underlying cryptography modules, and more.
 .
 wolfSSL also includes an OpenSSL compatibility interface with the
 most commonly used OpenSSL functions.
 .
 This package contains the development files.
 .
 wolfSSL is solely provided as an alternative to OpenSSL for
 packages whose licenses are incompatible to Apache 2.0. For details,
 please see Bug#1023697.
